<?php
 
/**
 * Define all the backup steps that will be used by the backup_choice_activity_task
 */

/**
 * Define the complete certificateswall structure for backup, with file and id annotations
 */     
class backup_certificateswall_activity_structure_step extends backup_activity_structure_step {
	 
	    protected function define_structure() {
 
	    	    // To know if we are including userinfo
	    	    $userinfo = $this->get_setting_value('userinfo');

	    	    // Define each element separated
	    	    $certificateswall = new backup_nested_element('certificateswall', array('id'), array(
	    	    	    'name', 'intro', 'introformat', 'emailteachers','emailothers',
	    	    	    'certificateidformat', 'certificatecustomformat', 'coursehours', 'certificatetime',
	    	    	    'lastnumber', 'certificateassigndate', 'certificateenddate', 'allowautoissue',
	    	    	    'minimumgrade','emailstudent','timemodified','certificateinfo'));
  
	    	    $issues = new backup_nested_element('issues');

	    	    $issue = new backup_nested_element('issue', array('id'), array(
	    	    	    'userid', 'timecreated','studentname','code','classname',
	    	    	    'certdate','reportgrade','mailed','cwcertid','cwuserid','cwlink'));
	    	    // Build the tree
	    	    $certificateswall->add_child($issues);
	    	    $issues->add_child($issue);
	    	    // Define sources
	    	    $certificateswall->set_source_table('certificateswall', array('id' => backup::VAR_ACTIVITYID));
 
	    	    
 
	    	    // All the rest of elements only happen if we are including user info
	    	    if ($userinfo) {
	    	    	    $issue->set_source_sql('
	    	    	    	    SELECT *
	    	    	    	    FROM {certificateswall_issues}
	    	    	    	    WHERE certificateid = ?',
	    	    	    	    array(backup::VAR_PARENTID));
	    	    }
	    	    // Define id annotations
	    	    $issue->annotate_ids('user', 'userid');
 
	    	    // Define file annotations
	    	    $certificateswall->annotate_files('mod_certificateswall', 'intro', null); // This file area hasn't itemid
	    	    // Return the root element (certificateswall), wrapped into standard activity structure

	    	    return $this->prepare_activity_structure($certificateswall);
 
	    }
}