<?php

 /**
 * Structure step to restore one certificateswall activity
 */
class restore_certificateswall_activity_structure_step extends restore_activity_structure_step {
 
    protected function define_structure() {
        $paths = array();
        $userinfo = $this->get_setting_value('userinfo');
 
        $paths[] = new restore_path_element('certificateswall', '/activity/certificateswall');
        if ($userinfo) {
            $paths[] = new restore_path_element('certificateswall_issue', '/activity/certificateswall/issues/issue');
        }
        // Return the paths wrapped into standard activity structure
        return $this->prepare_activity_structure($paths);
    }
 
    protected function process_certificateswall($data) {
        global $DB;
        $data = (object)$data;
        $oldid = $data->id;
        $data->course = $this->get_courseid();
 
        $data->timemodified = $this->apply_date_offset($data->timemodified);
        // insert the certificateswall record
        $newitemid = $DB->insert_record('certificateswall', $data);
        // immediately after inserting "activity" record, call this
        $this->apply_activity_instance($newitemid);
    }
 
    protected function process_certificateswall_issue($data) {
        global $DB;
        $data = (object)$data;
        $oldid = $data->id;
 
        $data->certificateid = $this->get_new_parentid('certificateswall');
        $data->userid = $this->get_mappingid('user', $data->userid);
        $data->timecreated = $this->apply_date_offset($data->timecreated);
        $newitemid = $DB->insert_record('certificateswall_issues', $data);
        // No need to save this mapping as far as nothing depend on it
        // (child paths, file areas nor links decoder)
    }
 
    protected function after_execute() {
        // Add certificateswall related files, no need to match by itemname (just internally handled context)
        $this->add_related_files('mod_certificateswall', 'intro', null);
    }
}