<?php  // $Id: version.php,v 3.1.0

require_once('../../config.php');
require_once('lib.php');

global $DB,$CFG;

$id   = required_param('id', PARAM_INT);          // Course module ID
$sort = optional_param('sort', '', PARAM_RAW);
$download = optional_param('download', '', PARAM_ALPHA);
$action = optional_param('action', '', PARAM_ALPHA);

$url = new moodle_url('/mod/certificateswall/report.php', array('id'=>$id));
if ($download !== '') {
$url->param('download', $download);
}
if ($action !== '') {
$url->param('action', $action);
}
$PAGE->set_url($url);

if (! $cm = get_coursemodule_from_id('certificateswall', $id)) {
    error('Course Module ID was incorrect');
}

if (! $course = $DB->get_record('course', array('id'=> $cm->course))) {
error('Course is misconfigured');
}

require_login($course->id, false, $cm);
$context = get_context_instance(CONTEXT_MODULE, $cm->id);
require_capability('mod/certificateswall:manage', $context);

if (! $certificate = $DB->get_record('certificateswall', array('id'=> $cm->instance))) {
error('Certificate ID was incorrect');
}

if($action=='remove'){
	$isseuid=optional_param('isseuid', '', PARAM_INT);
	certificateswall_issue_delete($isseuid);

	$url = new moodle_url('/mod/certificateswall/report.php', array('id' => $id));
	redirect($url->out(false));
    
}elseif($action=='issue' || $action=='reissue'){
	$studentid=optional_param('userid', '', PARAM_INT);
	$user = $DB->get_record("user", array("id"=>$studentid));
	if(!$user){
		error('User ID was incorrect');
	}
	$auth='no';
	$us=certificateswall_api_createuser($user,$auth,$course);

	if($us->status=='ok'){
		$certrecord = $DB->get_record('certificateswall_issues', array('certificateid'=>$certificate->id, 'userid'=>$user->id));
		if(!$certrecord){
			certificateswall_prepare_issue($course, $user, $certificate,0,0);
			certificateswall_issue($course, null, $cm,$user);
			$certrecord = $DB->get_record('certificateswall_issues', array('certificateid'=>$certificate->id, 'userid'=>$user->id));
		}
		$cert=certificateswall_api_addcertificate($certrecord,$user,$course);

		if($cert->status=='ok'){	
			certificateswall_issue_update($certrecord,$cert->response->certificate,$course,$cm,$user,false);

			$url = new moodle_url('/mod/certificateswall/report.php', array('id' => $cm->id));
			redirect($url->out(false));
		}else{
			error($cert->message);
		}
	}elseif($us->status!='ok'){
		error($us->message);
	}
}

$strcertificates = get_string('modulenameplural', 'certificateswall');
$strcertificate  = get_string('modulename', 'certificateswall');
$strto = get_string('awardedto', 'certificateswall');
$strdate = get_string('receiveddate', 'certificateswall');
$strgrade = get_string('grade','certificateswall');
$strcode = get_string('code', 'certificateswall');
$strlink = get_string('link', 'certificateswall');
$strreport= get_string('report', 'certificateswall');
$strdelete= get_string('reportdelete', 'certificateswall');

add_to_log($course->id, 'certificateswall', 'view', "report.php?id=$cm->id", '$certificate->id', $cm->id);

if (!$download) {
	$PAGE->navbar->add($strreport);
	$PAGE->set_title(format_string($certificate->name).": $strreport");
	$PAGE->set_heading($course->fullname);
	echo $OUTPUT->header();
	/// Check to see if groups are being used in this choice
	$groupmode = groups_get_activity_groupmode($cm);
	if ($groupmode) {
	    groups_get_activity_group($cm, true);
	    groups_print_activity_menu($cm, $CFG->wwwroot . '/mod/certificate/report.php?id='.$id);
	}
} else {
	$groupmode = groups_get_activity_groupmode($cm);
}

$students=certificateswall_get_course_students($certificate,$cm);

$sqlsort = 's.studentname ASC';
//or to sort by date:
// $sqlsort = 's.certdate ASC';
$users = certificateswall_get_issues($certificate->id, $sqlsort, $groupmode, $cm);

if ($download == "ods") {
	certificateswall_report_exportODS($users,$course,$certificate);
}
//print spreadsheet if one is asked for:
if ($download == "xls") {
	certificateswall_report_exportXLS($users,$course,$certificate);
}
// print text file
if ($download == "txt") {
	certificateswall_report_exportTXT($users,$course,$certificate);
}

echo '<br />';
echo $OUTPUT->heading(get_string('modulenameplural', 'certificateswall'));
    
$info=certificateswall_get_remote_information($certificate,$course);

if($CFG->certificateswall_function=='demo'){
	echo '<div style="background-color:#FFCECE;padding:4px;border:1px solid #FF5959; width:100%;">';
	echo '<h2 align="center">'.get_string('demomodeison', 'certificateswall').'</h2>';
	echo '<p align="center">'.get_string('demomodeisoncomments', 'certificateswall').'</p>';
	echo '</div>';
}

if(!$users) {
	echo('<h3>There are no issued certificates</h3>');
}else{
	$table = new html_table();
	$table->width = "95%";
	$table->tablealign = "center";
	$table->head  = array ($strto, $strdate, $strgrade, $strcode,$strlink,$strdelete);
	$table->align = array ("LEFT", "LEFT", "CENTER", "CENTER");
	foreach ($users as $user) {
		$name = $OUTPUT->user_picture($user).'<a href="'.$CFG->wwwroot.'/user/view.php?id='.$user->id.'&course='.$course->id.'">'.$user->studentname.'</a>';
		//$date = userdate($user->certdate).certificateswall_print_user_files($certificate, $user->id, $context->id);
		$date = userdate($user->certdate);
		if ($user->reportgrade != null) {
		    $grade = $user->reportgrade;
		} else {
		    $grade = get_string('notapplicable','certificateswall');
		}
		$code = $user->code;
		
		$options = array();
		$options["id"] = "$cm->id";
		$options["code"] = $user->code;
		$options["userid"] = (!isset($user->userid))?$user->id:$user->userid;
		$options["isseuid"] = $user->issueid;
		$options["action"] = "remove";
		$delete=$OUTPUT->single_button(new moodle_url("report.php", $options), '[DEL]');
		
		$link='<a href="'.$user->cwlink.'" target="_blank">View certificate</a>';
		
		$options = array();
		$options["id"] = "$cm->id";
		$options["code"] = $user->code;
		$options["userid"] = (!isset($user->userid))?$user->id:$user->userid;
		$options["isseuid"] = $user->issueid;
		$options["action"] = "remove";
		$delete=$OUTPUT->single_button(new moodle_url("report.php", $options), '[DEL]');
		
		$table->data[] = array ($name, $date, $grade, $code, $link,$delete);
	}
	
	echo '<br />';
	echo html_writer::table($table);
	
	//now give links for downloading spreadsheets.
	echo "<br />\n";
	echo "<center><table class=\"downloadreport\"><tr>\n";
	echo "<td>";
	$downloadoptions = array();
	$options = array();
	$options["id"] = "$cm->id";
	$options["download"] = "ods";
	echo $OUTPUT->single_button(new moodle_url("report.php", $options), get_string("downloadods"));
	
	echo "</td><td>";
	$options["download"] = "xls";
	echo $OUTPUT->single_button(new moodle_url("report.php", $options), get_string("downloadexcel"));
	echo "</td><td>";
	$options["download"] = "txt";
	echo $OUTPUT->single_button(new moodle_url("report.php", $options), get_string("downloadtext"));
	echo "</td></tr></table></center>";
}

if($students){
	echo '<h2>'.get_string('studentwithoutcert', 'certificateswall').'</h2>';
	
	$table = new html_table();
	$table->width = "95%";
	$table->tablealign = "center";
	$table->head  = array (get_string("fullname"), get_string('grade','certificateswall'), get_string('issuecertificate','certificateswall'));
	$table->align = array ("LEFT", "LEFT", "CENTER");
	foreach ($students as $student) {
		$name = $OUTPUT->user_picture($student).'<a href="'.$CFG->wwwroot.'/user/view.php?id='.$student->id.'&course='.$course->id.'">'.fullname($student).'</a>';
		$grade = certificateswall_print_course_grade($course,$student);
		$grade=$grade->percentage;
		$options = array();
		$options["id"] = "$cm->id";
		$options["userid"] = $student->id;
		$options["action"] = "issue";
		
		$issue=$OUTPUT->single_button(new moodle_url("report.php", $options), '[ ISSUE A CERTIFICATE ]');
		$table->data[] = array ($name, $grade,$issue);
	}
	
	echo '<br />';
	echo html_writer::table($table);
}



echo '<br><br><br><h2>'.get_string('certificatedemo', 'certificateswall').'</h2>';
if($CFG->certificateswall_function=='demo'){
	echo '<div style="background-color:#FFCECE;padding:1px;border:1px solid #FF5959; width:100%;">'.get_string('demomodeyoucanedittemplate', 'certificateswall').'</div>';
}else{
	echo  '<p>'.get_string('toedityourtemplategotocw', 'certificateswall').'</p>';
}
echo '<p align="center"><img src="'.$info->demoimages->big.'"></p>';

echo $OUTPUT->footer($course);
    
//===============================+++++++++++++++++++++++++++++++++============================================
function certificateswall_report_exportODS($users,$course,$certificate){
	global $CFG;
	require_once("$CFG->libdir/odslib.class.php");
	
	/// Calculate file name
	$filename = clean_filename("$course->shortname ".strip_tags(format_string($certificate->name,true))).'.ods';
	/// Creating a workbook
	$workbook = new MoodleODSWorkbook("-");
	/// Send HTTP headers
	$workbook->send($filename);
	/// Creating the first worksheet
	$myxls =& $workbook->add_worksheet(get_string('report', 'certificateswall'));
	
	/// Print names of all the fields
	$myxls->write_string(0,0,get_string("lastname"));
	$myxls->write_string(0,1,get_string("firstname"));
	$myxls->write_string(0,2,get_string("idnumber"));
	$myxls->write_string(0,3,get_string("group"));
	$myxls->write_string(0,4,get_string('receiveddate', 'certificateswall'));
	$myxls->write_string(0,5,get_string('grade','certificateswall'));
	$myxls->write_string(0,6,get_string('code', 'certificateswall'));
	$myxls->write_string(0,7,get_string('link', 'certificateswall'));
	
	
	/// generate the data for the body of the spreadsheet
	$i=0;
	$row=1;
	if ($users) {
	    foreach ($users as $user) {
		$myxls->write_string($row,0,$user->lastname);
		$myxls->write_string($row,1,$user->firstname);
		$studentid=(!empty($user->idnumber) ? $user->idnumber : " ");
		$myxls->write_string($row,2,$studentid);
		$ug2 = '';
		if ($usergrps = groups_get_all_groups($course->id, $user->id)) {
		    foreach ($usergrps as $ug) {
			$ug2 = $ug2. $ug->name;
		    }
		}
		$myxls->write_string($row,3,$ug2);
		$myxls->write_string($row,4,userdate($user->certdate));
		if ($user->reportgrade != null) {
		    $grade = $user->reportgrade;
		} else {
		    $grade = get_string('notapplicable','certificateswall');
		}
		$myxls->write_string($row,5,$grade);
		$myxls->write_string($row,6,$user->code);
		//if($CFG->certificateswall_integration!='simple'){
			$myxls->write_string($row,7,$user->cwlink);
		//}
		$row++;
	    }
	    $pos=6;
	}
	/// Close the workbook
	$workbook->close();
	exit;
}
function certificateswall_report_exportXLS($users,$course,$certificate){
	global $CFG;
	require_once("$CFG->libdir/excellib.class.php");

	/// Calculate file name
	$filename = clean_filename("$course->shortname ".strip_tags(format_string($certificate->name,true))).'.xls';
	/// Creating a workbook
	$workbook = new MoodleExcelWorkbook("-");
	/// Send HTTP headers
	$workbook->send($filename);
	/// Creating the first worksheet
	$myxls =& $workbook->add_worksheet(get_string('report', 'certificateswall'));
	
	/// Print names of all the fields
	$myxls->write_string(0,0,get_string("lastname"));
	$myxls->write_string(0,1,get_string("firstname"));
	$myxls->write_string(0,2,get_string("idnumber"));
	$myxls->write_string(0,3,get_string("group"));
	$myxls->write_string(0,4,get_string('receiveddate', 'certificateswall'));
	$myxls->write_string(0,5,get_string('grade','certificateswall'));
	$myxls->write_string(0,6,get_string('code', 'certificateswall'));
	$myxls->write_string(0,7,get_string('link', 'certificateswall'));
	
	
	/// generate the data for the body of the spreadsheet
	$i=0;
	$row=1;
	if ($users) {
		foreach ($users as $user) {
			$myxls->write_string($row,0,$user->lastname);
			$myxls->write_string($row,1,$user->firstname);
			$studentid=(!empty($user->idnumber) ? $user->idnumber : " ");
			$myxls->write_string($row,2,$studentid);
			$ug2 = '';
			if ($usergrps = groups_get_all_groups($course->id, $user->id)) {
			    foreach ($usergrps as $ug) {
				$ug2 = $ug2. $ug->name;
			    }
			}
			$myxls->write_string($row,3,$ug2);
			$myxls->write_string($row,4,userdate($user->certdate));
			if ($user->reportgrade != null) {
			    $grade = $user->reportgrade;
			} else {
			    $grade = get_string('notapplicable','certificateswall');
			}
			$myxls->write_string($row,5,$grade);
			$myxls->write_string($row,6,$user->code);
			$myxls->write_string($row,7,$user->cwlink);
			$row++;
		}
		$pos=6;
	}
	/// Close the workbook
	$workbook->close();
	exit;
}
function certificateswall_report_exportTXT($users,$course,$certificate){
	$filename = clean_filename("$course->shortname ".strip_tags(format_string($certificate->name,true))).'.txt';

	header("Content-Type: application/download\n");
	header("Content-Disposition: attachment; filename=\"$filename\"");
	header("Expires: 0");
	header("Cache-Control: must-revalidate,post-check=0,pre-check=0");
	header("Pragma: public");

	/// Print names of all the fields

	echo get_string("firstname")."\t".get_string("lastname") . "\t". get_string("idnumber") . "\t";
	echo get_string("group"). "\t";
	echo get_string('receiveddate', 'certificateswall'). "\t";
	echo get_string('grade','certificateswall'). "\t";
	echo get_string('code', 'certificateswall'). "\t";
	echo get_string('link', 'certificateswall'). "\n";
	
	/// generate the data for the body of the spreadsheet
	$i=0;
	$row=1;
	if ($users) foreach ($users as $user) {
		echo $user->lastname;
		echo "\t".$user->firstname;
		$studentid = " ";
		if (!empty($user->idnumber)) {
		$studentid = $user->idnumber;
		}
		echo "\t". $studentid."\t";
		$ug2 = '';
		if ($usergrps = groups_get_all_groups($course->id, $user->id)) {
		foreach ($usergrps as $ug) {
		    $ug2 = $ug2. $ug->name;
		}
		}
		echo $ug2. "\t";
		echo userdate($user->certdate)."\t";
		if ($user->reportgrade != null) {
		$grade = $user->reportgrade;
		} else {
		$grade = get_string('notapplicable','certificateswall');
		}
		echo $grade."\t";
		echo $user->code."\t";
		echo $user->cwlink."\n";
		$row++;
	}
	exit;
}