<?PHP // $Id: version.php

require_once('../../config.php');
require_once('lib.php');


$id = required_param('id', PARAM_INT);    // Course Module ID
$action = optional_param('action', '', PARAM_ALPHA);

if (! $cm = get_coursemodule_from_id('certificateswall', $id)) {	
    error('Course Module ID was incorrect');
}
if (! $course = $DB->get_record('course', array('id'=> $cm->course))) {
    error('course is misconfigured');
}
if (! $certificate = $DB->get_record('certificateswall', array('id'=> $cm->instance))) {
    error('course module is incorrect');
}

require_login($course->id, true, $cm);
$context = get_context_instance(CONTEXT_MODULE, $cm->id);
require_capability('mod/certificateswall:view', $context);

if (has_capability('mod/certificateswall:manage', $context)) {
	$url = new moodle_url('/mod/certificateswall/report.php', array('id' => $cm->id));
	redirect($url->out(false));
}

// log update
add_to_log($course->id, 'certificateswall', 'view', "view.php?id=$cm->id", $certificate->id, $cm->id);
$completion=new completion_info($course);
$completion->set_module_viewed($cm);

if($action=='generate'){
	// Create new certrecord
	$cwcertid=0;
	$cwuserid=0;
	//if($CFG->certificateswall_integration!='simple' || $CFG->certificateswall_function=='demo'){

		$auth=(optional_param('sendauthemail', '', PARAM_ALPHA)!='yes')?'no':'yes';

		$us=certificateswall_api_createuser($USER,$auth,$course);

		if($us->status=='ok' && $us->response->readytoaddcertificates=='yes'){
			$certrecord = $DB->get_record('certificateswall_issues', array('certificateid'=>$certificate->id, 'userid'=>$USER->id));
			if(!$certrecord){
				certificateswall_prepare_issue($course, $USER, $certificate,$cwcertid,$cwuserid);
				certificateswall_issue($course, null, $cm,null,true);
				$certrecord = $DB->get_record('certificateswall_issues', array('certificateid'=>$certificate->id, 'userid'=>$USER->id));
			}
			$cert=certificateswall_api_addcertificate($certrecord,$USER,$course);

			if($cert->status=='ok'){				
				certificateswall_issue_update($certrecord,$cert->response->certificate);

				$url = new moodle_url('/mod/certificateswall/view.php', array('id' => $cm->id));
				redirect($url->out(false));
			}else{
				error($cert->message);
			}
		}elseif($us->status=='ok' && $us->response->readytoaddcertificates=='no'){
			//show message to check email with confirmation link
			$url = new moodle_url('/mod/certificateswall/view.php', array('id' => $cm->id,'action'=>'authrequested'));
			redirect($url->out(false));
		}elseif($us->status=='error_exists'){
			//show form with request for access
			$url = new moodle_url('/mod/certificateswall/view.php', array('id' => $cm->id,'action'=>'createwithauthrequest'));
			redirect($url->out(false));
		}elseif($us->status!='ok'){
			error($us->message);
		}
	//}else{
	//	certificateswall_prepare_issue($course, $USER, $certificate,$cwcertid,$cwuserid);
	//	certificateswall_issue($course, null, $cm);
	//	$url = new moodle_url('/mod/certificateswall/view.php', array('id' => $cm->id));
	//	redirect($url->out(false));
	//}
	exit;
}elseif($action=='print'){
	//get print link. if success then redirect to the link
	$certrecord = $DB->get_record('certificateswall_issues', array('certificateid'=>$certificate->id, 'userid'=>$USER->id));
	$r=certificateswall_api_get_print_url($certrecord,$USER,$course);
	if($r->status=='ok'){
		$link=$r->response->link;
		$url = new moodle_url($link);
		redirect($url->out(false));
	}
	error($r->message);
}

// Initialize $PAGE, compute blocks
$PAGE->set_url('/mod/certificateswall/view.php', array('id' => $cm->id));
$PAGE->set_context($context);
$PAGE->set_cm($cm);


$certrecord = $DB->get_record('certificateswall_issues', array('certificateid'=>$certificate->id, 'userid'=>$USER->id));

// Load some strings
$strreviewcertificate = get_string('reviewcertificate', 'certificateswall');
$strgetcertificate = get_string('getcertificate', 'certificateswall');
$strgrade = get_string('grade', 'certificateswall');
$strcoursegrade = get_string('coursegrade', 'certificateswall');
$strcredithours = get_string('credithours', 'certificateswall');

$grade=certificateswall_print_course_grade($course);
//echo $grade;
//exit;

certificateswall_view_header($course, $certificate, $cm);
echo '<p align="center">'.get_string('currentgrade', 'certificateswall').'</p><h2 align="center">'.$grade->percentage.'</h2>';

if($certrecord){
		echo '<table align="center"><tr><td  valign="top">';
		echo '<h1 align="center"><a href="'.$certrecord->cwlink.'" target="_blank">'.get_string('viewyourcertificateoncw', 'certificateswall').'</a></h1>';
		echo '<p align="center"><a href="'._CERTIFICATESWALL_ENDPOINT.'content/personal.html" target="_blank">'.get_string('whattodowithcertificate', 'certificateswall').'</a></p>';
		echo '</td><td width="100" valign="top" style="padding-left:40px;">';
		echo '<a href="'.$CFG->wwwroot.'/mod/certificateswall/view.php?id='.$cm->id.'&action=print" target="_blank" title="Print certificate">'.
			'<img src="'.$CFG->wwwroot.'/mod/certificateswall/images/print.png" alt="print certificate"></a>';
		echo '</td></tr></table>';
		
		$link=certificateswall_get_link_for_iframe($certrecord);
		if($link!=''){
			echo '<center><iframe width="670" height="670" src="'.$link.'" frameBorder="0" scrolling="no"></iframe></center>';
		}

		//echo '<p align="center">'.get_string('howtouseextended', 'certificateswall').'</p>';
	//}
}elseif($grade->points>=$certificate->minimumgrade && $certificate->allowautoissue==1){
	
	echo '<center>';
	if($action=='createwithauthrequest'){
		echo '<p>'.get_string('requestauthhint', 'certificateswall').'</p>';
		$button = new single_button(new moodle_url('/mod/certificateswall/view.php', array('id'=>$cm->id, 'action'=>'generate','sendauthemail'=>'yes')),
			get_string('requestauth', 'certificateswall'), 'get');
		echo $OUTPUT->render($button);
	}else{
		$t=get_string('getcertificate', 'certificateswall');
		$button = new single_button(new moodle_url('/mod/certificateswall/view.php', array('id'=>$cm->id, 'action'=>'generate')),$t, 'get');
		echo $OUTPUT->render($button);
	}
	echo '</center>';
	
}elseif($grade->points<$certificate->minimumgrade && $certificate->allowautoissue==1){
	echo '<p align="center">'.sprintf(get_string('musthavesomegrade', 'certificateswall'),$certificate->minimumgrade).'</p>';
}else{
	echo '<p align="center">'.get_string('youhavenocertificateissued', 'certificateswall').'</p>';
}

echo $OUTPUT->footer($course);
exit;
